use std::path::Path;

use rusqlite::{Connection, Result};

use super::Entry;

pub fn from_path<P>(path: P) -> Result<Vec<Entry>>
where
    P: AsRef<Path>,
{
    let path = path.as_ref();

    let conn = Connection::open(path)?;

    let mut stmt = conn.prepare("SELECT day, hours FROM debit")?;
    let iter = stmt.query_map([], |row| {
        let date = row.get(0)?;
        let hours = row.get(1)?;

        Ok(Entry { date, hours })
    })?;

    Ok(iter.map(Result::unwrap).collect())
}
